//
//  ELAILinkBleManager+NoiseMeter.h
//  AILinkBleSDK
//
//  Created by LarryZhang on 2022/12/21.
//

#import <AILinkBleSDK/ELAILinkBleManager.h>

@class ELTLVModel;

NS_ASSUME_NONNULL_BEGIN

@interface ELAILinkBleManager (NoiseMeter)

//APP获取设备功能列表 //0x01    CMD：APP获取设备功能列表
- (void)noiseMeterRequestDeviceFunctions;

//APP获取设备状态 //0x03    CMD：APP获取设备状态
- (void)noiseMeterRequestDeviceStatus;

//APP设置/获取参数 //0x05    CMD：APP设置/获取参数
- (void)noiseMeterRequestDeviceSettings;
- (void)noiseMeterSendDeviceSettings:(NSArray<ELTLVModel *> *)tlvs;

@end

@interface ELAILinkBleManager (NoiseMeterTLV)

//0x01:频率计权A/C
+ (ELTLVModel *)tlvFrequencyWeightingA;
+ (ELTLVModel *)tlvFrequencyWeightingC;

//0x03:测量等级及范围
+ (ELTLVModel *)tlvMeasurementLevelSwitchUp;
+ (ELTLVModel *)tlvMeasurementLevelSwitchDown;

//0x04:Max/Min模式
+ (ELTLVModel *)tlvMaxMinModelNormal;
+ (ELTLVModel *)tlvMaxMinModelMin;
+ (ELTLVModel *)tlvMaxMinModelMax;

//0x05:时间加权(Fast/Slow)
+ (ELTLVModel *)tlvTimeWeightedFast;
+ (ELTLVModel *)tlvTimeWeightedSlow;

//0x06:数值保持(hold)
+ (ELTLVModel *)tlvValueHoldNormal;
+ (ELTLVModel *)tlvValueHoldWithValue:(UInt16)value;

//0x07:报警
+ (ELTLVModel *)tlvAlarmOff;
+ (ELTLVModel *)tlvAlarmStop; //关闭当前报警(关闭当前报警,指当前触发了报警,之后可手动关闭当次报警,但是并不会关闭报警功能.)
+ (ELTLVModel *)tlvAlarmOn:(NSInteger)alarmValue;

//0x08:背光
+ (ELTLVModel *)tlvBacklightOn;
+ (ELTLVModel *)tlvBacklightOff;

//0x0A:历史
+ (ELTLVModel *)tlvRequestHistoryWithTimestamp:(UInt32)timestamp;
+ (ELTLVModel *)tlvReleaseHistory;

//0x0C:设备绑定
+ (ELTLVModel *)tlvDeviceBindingRequest;
+ (ELTLVModel *)tlvDeviceBindingCancel;


@end

NS_ASSUME_NONNULL_END
