//
//  ELNoiseMeterBleParser.h
//  AILinkBleSDK
//
//  Created by LarryZhang on 2022/12/21.
//

#import <Foundation/Foundation.h>
#import "ELNoiseMeterBleHeader.h"

NS_ASSUME_NONNULL_BEGIN

@class ELNoiseMeterBleFunctionModel;
@class ELNoiseMeterBleStatusModel;
@class ELNoiseMeterBleSettingModel;

@protocol ELNoiseMeterBleParserDelegate;

@interface ELNoiseMeterBleParser : NSObject

@property (nonatomic, weak) id<ELNoiseMeterBleParserDelegate> delegate;

/// 设备返回支持功能列表Model
@property (nonatomic, strong) ELNoiseMeterBleFunctionModel *functionModel;

/// 设备返回状态Model
@property (nonatomic, strong) ELNoiseMeterBleStatusModel *statusModel;

/// 获取参数Model
@property (nonatomic, strong) ELNoiseMeterBleSettingModel *settingModel;


- (void)parseData:(NSData *)payload;

@end

@protocol ELNoiseMeterBleParserDelegate <NSObject>

/// MCU主控回应设备功能列表
- (void)noiseMeterBleParser:(ELNoiseMeterBleParser *)bleParser returnFunctionWithTlvType:(ELNoiseMeterTLVType)tlvType;

/// MCU主控回应设备状态
- (void)noiseMeterBleParser:(ELNoiseMeterBleParser *)bleParser returnStatusWithTlvType:(ELNoiseMeterTLVType)tlvType;

/// MCU主控回应设备参数
- (void)noiseMeterBleParser:(ELNoiseMeterBleParser *)bleParser returnSettingWithTlvType:(ELNoiseMeterTLVType)tlvType;

@end

NS_ASSUME_NONNULL_END
