//
//  ELDemoDeviceModel.m
//  AILinkBleSDK_Example
//
//  Created by LarryZhang on 2023/2/4.
//  Copyright © 2023 zhengzida. All rights reserved.
//

#import "ELDemoDeviceModel.h"

@implementation ELDemoDeviceModel

+ (instancetype)modelWithIndex:(NSString *)index imageName:(NSString *)imageName title:(NSString *)title subtitle:(NSString *)subtitle entryVCName:(NSString *)entryVCName {
    return [self modelWithIndex:index imageName:imageName title:title subtitle:subtitle entryVCName:entryVCName cids:@[] newType:NO];
}

+ (instancetype)modelWithIndex:(NSString *)index imageName:(NSString *)imageName title:(NSString *)title subtitle:(NSString *)subtitle entryVCName:(NSString *)entryVCName cids:(NSArray<NSNumber *> *)cids {
    return [self modelWithIndex:index imageName:imageName title:title subtitle:subtitle entryVCName:entryVCName cids:cids newType:YES];
}

+ (instancetype)modelWithIndex:(NSString *)index imageName:(NSString *)imageName title:(NSString *)title subtitle:(NSString *)subtitle entryVCName:(NSString *)entryVCName cids:(NSArray<NSNumber *> *)cids newType:(BOOL)newType {
    ELDemoDeviceModel *model = [[ELDemoDeviceModel alloc] init];
    model.index = index;
    model.imageName = imageName;
    model.titleText = title;
    model.subtitleText = subtitle;
    model.entryVCName = entryVCName;
    model.cids = cids;
    model.newType = newType;
    
    return model;
}


@end
